/****************************************************************************
 *
 * Copyright 2016 Samsung Electronics All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the License.
 *
 ****************************************************************************/
/* coap.h -- main header file for CoAP stack
 *
 * Copyright (C) 2010--2012 Olaf Bergmann <bergmann@tzi.org>
 *
 * This file is part of the CoAP library libcoap. Please see
 * README for terms of use.
 */

#ifndef _COAP_H_
#define _COAP_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <protocols/libcoap/config.h>
#include <protocols/libcoap/debug.h>
#include <protocols/libcoap/mem.h>
#include <protocols/libcoap/coap_list.h>
#include <protocols/libcoap/pdu.h>
#include <protocols/libcoap/option.h>
#include <protocols/libcoap/net.h>
#include <protocols/libcoap/encode.h>
#include <protocols/libcoap/str.h>
#include <protocols/libcoap/uri.h>
#include <protocols/libcoap/async.h>
#include <protocols/libcoap/resource.h>
#include <protocols/libcoap/subscribe.h>
#include <protocols/libcoap/block.h>

#ifdef __cplusplus
}
#endif
#endif							/* _COAP_H_ */
