/****************************************************************************
 *
 * Copyright 2018 Samsung Electronics All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the License.
 *
 ****************************************************************************/

#include "libcxx_tc_common.h"
#include "tc_containers.hpp"

extern "C"
{
	int tc_containers_main(void)
	{
#ifdef CONFIG_LIBCXX_UTC_CONTAINERS_MAP
		tc_libcxx_containers_map_access_at();
		tc_libcxx_containers_map_access_empty();
		tc_libcxx_containers_map_access_index_key();
		tc_libcxx_containers_map_access_index_rv_key();
		tc_libcxx_containers_map_access_iterator();
		tc_libcxx_containers_map_access_max_size();
		tc_libcxx_containers_map_access_size();
		tc_libcxx_containers_map_cons_alloc();
		tc_libcxx_containers_map_cons_compare();
		tc_libcxx_containers_map_cons_compare_alloc();
		tc_libcxx_containers_map_cons_copy();
		tc_libcxx_containers_map_cons_copy_alloc();
		tc_libcxx_containers_map_cons_default();
		tc_libcxx_containers_map_cons_default_noexcept();
		tc_libcxx_containers_map_cons_default_recursive();
		tc_libcxx_containers_map_cons_dtor_noexcept();
		tc_libcxx_containers_map_cons_initializer_list();
		tc_libcxx_containers_map_cons_initializer_list_compare();
		tc_libcxx_containers_map_cons_initializer_list_compare_alloc();
		tc_libcxx_containers_map_cons_iter_iter();
		tc_libcxx_containers_map_cons_iter_iter_comp();
		tc_libcxx_containers_map_cons_iter_iter_comp_alloc();
		tc_libcxx_containers_map_cons_move();
		tc_libcxx_containers_map_cons_move_alloc();
		tc_libcxx_containers_map_cons_move_assign();
		tc_libcxx_containers_map_cons_move_assign_noexcept();
		tc_libcxx_containers_map_cons_move_noexcept();
		tc_libcxx_containers_map_modifiers_clear();
		tc_libcxx_containers_map_modifiers_emplace();
		tc_libcxx_containers_map_modifiers_emplace_hint();
		tc_libcxx_containers_map_modifiers_erase_iter();
		tc_libcxx_containers_map_modifiers_erase_iter_iter();
		tc_libcxx_containers_map_modifiers_erase_key();
		tc_libcxx_containers_map_modifiers_insert_cv();
		tc_libcxx_containers_map_modifiers_insert_iter_cv();
		tc_libcxx_containers_map_modifiers_insert_iter_iter();
		tc_libcxx_containers_map_modifiers_insert_iter_rv();
		tc_libcxx_containers_map_modifiers_insert_rv();
		tc_libcxx_containers_map_ops_count();
		tc_libcxx_containers_map_special_swap_noexcept();
		tc_libcxx_containers_map_types();
		tc_libcxx_containers_multimap_cons_alloc();
		tc_libcxx_containers_multimap_cons_assign_initializer_list();
		tc_libcxx_containers_multimap_cons_compare();
		tc_libcxx_containers_multimap_cons_compare_alloc();
		tc_libcxx_containers_multimap_cons_copy();
		tc_libcxx_containers_multimap_cons_copy_alloc();
		tc_libcxx_containers_multimap_cons_copy_assign();
		tc_libcxx_containers_multimap_cons_default();
		tc_libcxx_containers_multimap_cons_default_noexcept();
		tc_libcxx_containers_multimap_cons_dtor_noexcept();
		tc_libcxx_containers_multimap_cons_initializer_list();
		tc_libcxx_containers_multimap_cons_initializer_list_compare();
		tc_libcxx_containers_multimap_cons_initializer_list_compare_alloc();
		tc_libcxx_containers_multimap_cons_iter_iter();
		tc_libcxx_containers_multimap_cons_iter_iter();
		tc_libcxx_containers_multimap_cons_iter_iter_comp();
		tc_libcxx_containers_multimap_cons_iter_iter_comp_alloc();
		tc_libcxx_containers_multimap_cons_move_alloc();
		tc_libcxx_containers_multimap_cons_move_assign();
		tc_libcxx_containers_multimap_cons_move_assign_noexcept();
		tc_libcxx_containers_multimap_cons_move_noexcept();
		tc_libcxx_containers_multimap_modifiers_clear();
		tc_libcxx_containers_multimap_modifiers_emplace();
		tc_libcxx_containers_multimap_modifiers_emplace_hint();
		tc_libcxx_containers_multimap_modifiers_erase_iter();
		tc_libcxx_containers_multimap_modifiers_erase_iter_iter();
		tc_libcxx_containers_multimap_modifiers_erase_key();
		tc_libcxx_containers_multimap_modifiers_insert_cv();
		tc_libcxx_containers_multimap_modifiers_insert_initializer_list();
		tc_libcxx_containers_multimap_modifiers_insert_iter_iter();
		tc_libcxx_containers_multimap_modifiers_insert_iter_rv();
		tc_libcxx_containers_multimap_ops_count();
		tc_libcxx_containers_multimap_special_swap_noexcept();
		tc_libcxx_containers_multimap_size();
		tc_libcxx_containers_multimap_types();
		tc_libcxx_containers_unord_map_types();
		tc_libcxx_containers_unord_map_find_const();
		tc_libcxx_containers_unord_map_iterators();
		tc_libcxx_containers_unord_map_swap_swap_non_member();
		tc_libcxx_containers_unord_map_swap_swap_noexcept();
		tc_libcxx_containers_unord_map_cnstr_allocator();
		tc_libcxx_containers_unord_map_cnstr_copy_alloc();
		tc_libcxx_containers_unord_map_cnstr_range_size_hash();
		tc_libcxx_containers_unord_map_cnstr_move_assign_noexcept();
		tc_libcxx_containers_unord_map_cnstr_assign_init();
		tc_libcxx_containers_unord_map_cnstr_range_size();
		tc_libcxx_containers_unord_map_cnstr_range();
		tc_libcxx_containers_unord_map_cnstr_init_size_hash_equal();
		tc_libcxx_containers_unord_map_cnstr_size_hash();
		tc_libcxx_containers_unord_map_cnstr_move();
		tc_libcxx_containers_unord_map_cnstr_assign_copy();
		tc_libcxx_containers_unord_map_cnstr_dtor_noexcept();
		tc_libcxx_containers_unord_map_cnstr_move_alloc();
		tc_libcxx_containers_unord_map_cnstr_init_size_hash();
		tc_libcxx_containers_unord_map_cnstr_move_noexcept();
		tc_libcxx_containers_unord_map_cnstr_copy();
		tc_libcxx_containers_unord_map_cnstr_init();
		tc_libcxx_containers_unord_map_cnstr_size_pass();
		tc_libcxx_containers_unord_map_cnstr_range_size_hash_equal();
		tc_libcxx_containers_unord_map_cnstr_default_noexcept();
		tc_libcxx_containers_unord_map_cnstr_init_size_hash_equal_allocator();
		tc_libcxx_containers_unord_map_cnstr_size_hash_equal();
		tc_libcxx_containers_unord_map_cnstr_range_size_hash_equal_allocator();
		tc_libcxx_containers_unord_map_cnstr_assign_move();
		tc_libcxx_containers_unord_map_cnstr_init_size();
		tc_libcxx_containers_unord_map_cnstr_size_hash_equal_allocator();
		tc_libcxx_containers_unord_map_cnstr_default();
		tc_libcxx_containers_unord_map_eq();
		tc_libcxx_containers_unord_map_bucket();
		tc_libcxx_containers_unord_map_equal_range_const();
		tc_libcxx_containers_unord_map_find_non_const();
		tc_libcxx_containers_unord_map_max_load_factor();
		tc_libcxx_containers_unord_map_swap_member();
		tc_libcxx_containers_unord_map_count();
		tc_libcxx_containers_unord_map_reserve();
		tc_libcxx_containers_unord_map_bucket_size();
		tc_libcxx_containers_unord_map_max_bucket_count();
		tc_libcxx_containers_unord_map_elem_at();
		tc_libcxx_containers_unord_map_elem_index();
		tc_libcxx_containers_unord_map_load_factor();
		tc_libcxx_containers_unord_map_bucket_count();
		tc_libcxx_containers_unord_map_rehash();
		tc_libcxx_containers_unord_map_modifiers_insert_const_lvalue();
		tc_libcxx_containers_unord_map_modifiers_insert_hint_rvalue();
		tc_libcxx_containers_unord_map_modifiers_insert_init();
		tc_libcxx_containers_unord_map_modifiers_emplace_hint();
		tc_libcxx_containers_unord_map_modifiers_insert_rvalue();
		tc_libcxx_containers_unord_map_modifiers_erase_key();
		tc_libcxx_containers_unord_map_modifiers_erase_range();
		tc_libcxx_containers_unord_map_modifiers_emplace();
		tc_libcxx_containers_unord_map_modifiers_erase_const_iter();
		tc_libcxx_containers_unord_map_modifiers_clear();
		tc_libcxx_containers_unord_map_modifiers_insert_range();
		tc_libcxx_containers_unord_map_modifiers_insert_hint_const_lvalue();
		tc_libcxx_containers_unord_map_max_size();
		tc_libcxx_containers_unord_map_local_iterators();
		tc_libcxx_containers_unord_multimap_types();
		tc_libcxx_containers_unord_multimap_find_const();
		tc_libcxx_containers_unord_multimap_swap_swap_non_member();
		tc_libcxx_containers_unord_multimap_swap_swap_noexcept();
		tc_libcxx_containers_unord_multimap_iterators();
		tc_libcxx_containers_unord_multimap_eq();
		tc_libcxx_containers_unord_multimap_cnstr_allocator();
		tc_libcxx_containers_unord_multimap_cnstr_copy_alloc();
		tc_libcxx_containers_unord_multimap_cnstr_range_size_hash();
		tc_libcxx_containers_unord_multimap_cnstr_move_assign_noexcept();
		tc_libcxx_containers_unord_multimap_cnstr_assign_init();
		tc_libcxx_containers_unord_multimap_cnstr_range_size();
		tc_libcxx_containers_unord_multimap_cnstr_range();
		tc_libcxx_containers_unord_multimap_cnstr_init_size_hash_equal();
		tc_libcxx_containers_unord_multimap_cnstr_size_hash();
		tc_libcxx_containers_unord_multimap_cnstr_move();
		tc_libcxx_containers_unord_multimap_cnstr_assign_copy();
		tc_libcxx_containers_unord_multimap_cnstr_dtor_noexcept();
		tc_libcxx_containers_unord_multimap_cnstr_move_alloc();
		tc_libcxx_containers_unord_multimap_cnstr_init_size_hash();
		tc_libcxx_containers_unord_multimap_cnstr_move_noexcept();
		tc_libcxx_containers_unord_multimap_cnstr_copy();
		tc_libcxx_containers_unord_multimap_cnstr_init();
		tc_libcxx_containers_unord_multimap_cnstr_range_size_hash_equal();
		tc_libcxx_containers_unord_multimap_cnstr_default_noexcept();
		tc_libcxx_containers_unord_multimap_cnstr_init_size_hash_equal_allocator();
		tc_libcxx_containers_unord_multimap_cnstr_size_hash_equal();
		tc_libcxx_containers_unord_multimap_cnstr_range_size_hash_equal_allocator();
		tc_libcxx_containers_unord_multimap_cnstr_assign_move();
		tc_libcxx_containers_unord_multimap_cnstr_init_size();
		tc_libcxx_containers_unord_multimap_cnstr_size_hash_equal_allocator();
		tc_libcxx_containers_unord_multimap_cnstr_default();
		tc_libcxx_containers_unord_multimap_cnstr_size_pass();
		tc_libcxx_containers_unord_multimap_bucket();
		tc_libcxx_containers_unord_multimap_equal_range_const();
		tc_libcxx_containers_unord_multimap_find_non_const();
		tc_libcxx_containers_unord_multimap_max_load_factor();
		tc_libcxx_containers_unord_multimap_swap_member();
		tc_libcxx_containers_unord_multimap_count();
		tc_libcxx_containers_unord_multimap_reserve();
		tc_libcxx_containers_unord_multimap_bucket_size();
		tc_libcxx_containers_unord_multimap_max_bucket_count();
		tc_libcxx_containers_unord_multimap_load_factor();
		tc_libcxx_containers_unord_multimap_equal_range_non_const();
		tc_libcxx_containers_unord_multimap_bucket_count();
		tc_libcxx_containers_unord_multimap_rehash();
		tc_libcxx_containers_unord_multimap_max_size();
		tc_libcxx_containers_unord_multimap_modifiers_insert_const_lvalue();
		tc_libcxx_containers_unord_multimap_modifiers_insert_hint_rvalue();
		tc_libcxx_containers_unord_multimap_modifiers_insert_init();
		tc_libcxx_containers_unord_multimap_modifiers_emplace_hint();
		tc_libcxx_containers_unord_multimap_modifiers_insert_rvalue();
		tc_libcxx_containers_unord_multimap_modifiers_erase_key();
		tc_libcxx_containers_unord_multimap_modifiers_erase_range();
		tc_libcxx_containers_unord_multimap_modifiers_emplace();
		tc_libcxx_containers_unord_multimap_modifiers_erase_const_iter();
		tc_libcxx_containers_unord_multimap_modifiers_clear();
		tc_libcxx_containers_unord_multimap_modifiers_insert_range();
		tc_libcxx_containers_unord_multimap_modifiers_insert_hint_const_lvalue();
		tc_libcxx_containers_unord_multimap_local_iterators();
#endif

#ifdef CONFIG_LIBCXX_UTC_CONTAINERS_VECTOR
		//Vector TC's
		tc_libcxx_containers_vector_types();
		tc_libcxx_containers_vector_iterators();
		tc_libcxx_containers_vector_capacity_resize_size();
		tc_libcxx_containers_vector_capacity_shrink_to_fit();
		tc_libcxx_containers_vector_capacity_swap();
		tc_libcxx_containers_vector_capacity_capacity();
		tc_libcxx_containers_vector_capacity_reserve();
		tc_libcxx_containers_vector_capacity_resize_size_value();
		tc_libcxx_containers_vector_data_data_const();
		tc_libcxx_containers_vector_data_data();
		tc_libcxx_containers_vector_cons_construct_default();
		tc_libcxx_containers_vector_cons_copy_alloc();
		tc_libcxx_containers_vector_cons_move_assign_noexcept();
		tc_libcxx_containers_vector_cons_initializer_list();
		tc_libcxx_containers_vector_cons_initializer_list_alloc();
		tc_libcxx_containers_vector_cons_move();
		tc_libcxx_containers_vector_cons_assign_copy();
		tc_libcxx_containers_vector_cons_dtor_noexcept();
		tc_libcxx_containers_vector_cons_move_alloc();
		tc_libcxx_containers_vector_cons_assign_initializer_list();
		tc_libcxx_containers_vector_cons_move_noexcept();
		tc_libcxx_containers_vector_cons_construct_size_value();
		tc_libcxx_containers_vector_cons_copy();
		tc_libcxx_containers_vector_cons_op_equal_initializer_list();
		tc_libcxx_containers_vector_cons_default_noexcept();
		tc_libcxx_containers_vector_cons_assign_move();
		tc_libcxx_containers_vector_cons_construct_size_value_alloc();
		tc_libcxx_containers_vector_cons_construct_size();
		tc_libcxx_containers_vector_modifiers_emplace_back();
		tc_libcxx_containers_vector_modifiers_push_back_rvalue();
		tc_libcxx_containers_vector_modifiers_push_back();
		tc_libcxx_containers_vector_modifiers_erase_iter();
		tc_libcxx_containers_vector_modifiers_insert_iter_iter_iter();
		tc_libcxx_containers_vector_modifiers_insert_iter_rvalue();
		tc_libcxx_containers_vector_modifiers_emplace();
		tc_libcxx_containers_vector_modifiers_insert_iter_value();
		tc_libcxx_containers_vector_modifiers_insert_iter_initializer_list();
		tc_libcxx_containers_vector_modifiers_erase_iter_iter();
		tc_libcxx_containers_vector_modifiers_emplace_extra();
		tc_libcxx_containers_vector_special_swap();
		tc_libcxx_containers_vector_special_swap_noexcept();
		tc_libcxx_containers_vector_bool_resize_size();
		tc_libcxx_containers_vector_bool_construct_default();
		tc_libcxx_containers_vector_bool_shrink_to_fit();
		tc_libcxx_containers_vector_bool_copy_alloc();
		tc_libcxx_containers_vector_bool_types();
		tc_libcxx_containers_vector_bool_swap();
		tc_libcxx_containers_vector_bool_move_assign_noexcept();
		tc_libcxx_containers_vector_bool_initializer_list();
		tc_libcxx_containers_vector_bool_iterators();
		tc_libcxx_containers_vector_bool_push_back();
		tc_libcxx_containers_vector_bool_erase_iter();
		tc_libcxx_containers_vector_bool_initializer_list_alloc();
		tc_libcxx_containers_vector_bool_insert_iter_iter_iter();
		tc_libcxx_containers_vector_bool_construct_iter_iter();
		tc_libcxx_containers_vector_bool_insert_iter_value();
		tc_libcxx_containers_vector_bool_insert_iter_size_value();
		tc_libcxx_containers_vector_bool_move();
		tc_libcxx_containers_vector_bool_assign_copy();
		tc_libcxx_containers_vector_bool_dtor_noexcept();
		tc_libcxx_containers_vector_bool_capacity();
		tc_libcxx_containers_vector_bool_move_alloc();
		tc_libcxx_containers_vector_bool_assign_initializer_list();
		tc_libcxx_containers_vector_bool_move_noexcept();
		tc_libcxx_containers_vector_bool_insert_iter_initializer_list();
		tc_libcxx_containers_vector_bool_reserve();
		tc_libcxx_containers_vector_bool_construct_size_value();
		tc_libcxx_containers_vector_bool_copy();
		tc_libcxx_containers_vector_bool_construct_iter_iter_alloc();
		tc_libcxx_containers_vector_bool_op_equal_initializer_list();
		tc_libcxx_containers_vector_bool_default_noexcept();
		tc_libcxx_containers_vector_bool_assign_move();
		tc_libcxx_containers_vector_bool_erase_iter_iter();
		tc_libcxx_containers_vector_bool_swap_noexcept();
		tc_libcxx_containers_vector_bool_construct_size_value_alloc();
		tc_libcxx_containers_vector_bool_resize_size_value();
		tc_libcxx_containers_vector_bool_construct_size();
#endif

#ifdef CONFIG_LIBCXX_UTC_CONTAINERS_LIST
		//List TC's
		tc_libcxx_containers_list_types();
		tc_libcxx_containers_list_modifiers_pop_back();
		tc_libcxx_containers_list_modifiers_emplace_back();
		tc_libcxx_containers_list_modifiers_push_back_rvalue();
		tc_libcxx_containers_list_modifiers_push_back();
		tc_libcxx_containers_list_modifiers_erase_iter();
		tc_libcxx_containers_list_modifiers_insert_iter_iter_iter();
		tc_libcxx_containers_list_modifiers_insert_iter_rvalue();
		tc_libcxx_containers_list_modifiers_emplace();
		tc_libcxx_containers_list_modifiers_insert_iter_value();
		tc_libcxx_containers_list_modifiers_insert_iter_size_value();
		tc_libcxx_containers_list_modifiers_emplace_front();
		tc_libcxx_containers_list_modifiers_insert_iter_initializer_list();
		tc_libcxx_containers_list_modifiers_clear();
		tc_libcxx_containers_list_modifiers_pop_front();
		tc_libcxx_containers_list_modifiers_erase_iter_iter();
		tc_libcxx_containers_list_modifiers_push_front();
		tc_libcxx_containers_list_modifiers_push_front_rvalue();
		tc_libcxx_containers_list_cons_copy_alloc();
		tc_libcxx_containers_list_cons_move_assign_noexcept();
		tc_libcxx_containers_list_cons_initializer_list();
		tc_libcxx_containers_list_cons_initializer_list_alloc();
		tc_libcxx_containers_list_cons_size_value_alloc();
		tc_libcxx_containers_list_cons_move();
		tc_libcxx_containers_list_cons_default_stack_alloc();
		tc_libcxx_containers_list_cons_assign_copy();
		tc_libcxx_containers_list_cons_dtor_noexcept();
		tc_libcxx_containers_list_cons_move_alloc();
		tc_libcxx_containers_list_cons_assign_initializer_list();
		tc_libcxx_containers_list_cons_move_noexcept();
		tc_libcxx_containers_list_cons_copy();
		tc_libcxx_containers_list_cons_op_equal_initializer_list();
		tc_libcxx_containers_list_cons_default_noexcept();
		tc_libcxx_containers_list_cons_assign_move();
		tc_libcxx_containers_list_cons_size_type();
		tc_libcxx_containers_list_cons_default();
		tc_libcxx_containers_list_special_swap();
		tc_libcxx_containers_list_special_swap_noexcept();
		tc_libcxx_containers_list_iterators();
		tc_libcxx_containers_list_ops_remove_if();
		tc_libcxx_containers_list_ops_splice_pos_list_iter_iter();
		tc_libcxx_containers_list_ops_unique();
		tc_libcxx_containers_list_ops_sort();
		tc_libcxx_containers_list_ops_unique_pred();
		tc_libcxx_containers_list_ops_merge();
		tc_libcxx_containers_list_ops_splice_pos_list();
		tc_libcxx_containers_list_ops_splice_pos_list_iter();
		tc_libcxx_containers_list_ops_sort_comp();
		tc_libcxx_containers_list_ops_remove();
		tc_libcxx_containers_list_ops_reverse();
		tc_libcxx_containers_list_ops_merge_comp();
		tc_libcxx_containers_list_capacity_resize_size();
		tc_libcxx_containers_list_capacity_resize_size_value();
		tc_libcxx_containers_forwardlist_types();
		tc_libcxx_containers_forwardlist_cons_copy_alloc();
		tc_libcxx_containers_forwardlist_cons_assign_range();
		tc_libcxx_containers_forwardlist_cons_move_assign_noexcept();
		tc_libcxx_containers_forwardlist_cons_size_value_alloc();
		tc_libcxx_containers_forwardlist_cons_range_alloc();
		tc_libcxx_containers_forwardlist_cons_assign_init();
		tc_libcxx_containers_forwardlist_cons_range();
		tc_libcxx_containers_forwardlist_cons_move();
		tc_libcxx_containers_forwardlist_cons_assign_copy();
		tc_libcxx_containers_forwardlist_cons_dtor_noexcept();
		tc_libcxx_containers_forwardlist_cons_move_alloc();
		tc_libcxx_containers_forwardlist_cons_move_noexcept();
		tc_libcxx_containers_forwardlist_cons_copy();
		tc_libcxx_containers_forwardlist_cons_init();
		tc_libcxx_containers_forwardlist_cons_size();
		tc_libcxx_containers_forwardlist_cons_default_noexcept();
		tc_libcxx_containers_forwardlist_cons_assign_move();
		tc_libcxx_containers_forwardlist_cons_alloc_pass();
		tc_libcxx_containers_forwardlist_cons_assign_op_init();
		tc_libcxx_containers_forwardlist_cons_default();
		tc_libcxx_containers_forwardlist_cons_assign_size_value();
		tc_libcxx_containers_forwardlist_cons_size_value();
		tc_libcxx_containers_forwardlist_cons_init_alloc();
		tc_libcxx_containers_forwardlist_cons_size();
		tc_libcxx_containers_forwardlist_modifiers_erase_after_one();
		tc_libcxx_containers_forwardlist_modifiers_resize_size();
		tc_libcxx_containers_forwardlist_modifiers_insert_after_rv();
		tc_libcxx_containers_forwardlist_modifiers_insert_after_size_value();
		tc_libcxx_containers_forwardlist_modifiers_emplace_front();
		tc_libcxx_containers_forwardlist_modifiers_insert_after_const();
		tc_libcxx_containers_forwardlist_modifiers_insert_after_range();
		tc_libcxx_containers_forwardlist_modifiers_insert_after_init();
		tc_libcxx_containers_forwardlist_modifiers_clear();
		tc_libcxx_containers_forwardlist_modifiers_erase_after_many();
		tc_libcxx_containers_forwardlist_modifiers_pop_front();
		tc_libcxx_containers_forwardlist_modifiers_push_front_const();
		tc_libcxx_containers_forwardlist_modifiers_push_front_rv();
		tc_libcxx_containers_forwardlist_modifiers_resize_size_value();
		tc_libcxx_containers_forwardlist_modifiers_emplace_after();
		tc_libcxx_containers_forwardlist_access_front();
		tc_libcxx_containers_forwardlist_ops_remove_if();
		tc_libcxx_containers_forwardlist_ops_unique();
		tc_libcxx_containers_forwardlist_ops_sort();
		tc_libcxx_containers_forwardlist_ops_unique_pred();
		tc_libcxx_containers_forwardlist_ops_merge();
		tc_libcxx_containers_forwardlist_ops_splice_after_one();
		tc_libcxx_containers_forwardlist_ops_sort_pred();
		tc_libcxx_containers_forwardlist_ops_remove();
		tc_libcxx_containers_forwardlist_ops_reverse();
		tc_libcxx_containers_forwardlist_ops_merge_pred();
		tc_libcxx_containers_forwardlist_ops_splice_after_range();
		tc_libcxx_containers_forwardlist_ops_splice_after_flist();
		tc_libcxx_containers_forwardlist_iter_before_begin();
		tc_libcxx_containers_forwardlist_iter_iterators();
		tc_libcxx_containers_forwardlist_spec_member_swap();
		tc_libcxx_containers_forwardlist_spec_non_member_swap();
		tc_libcxx_containers_forwardlist_spec_relational();
		tc_libcxx_containers_forwardlist_spec_swap_noexcept();
#endif

		return 0;
	}
}


