/****************************************************************************
 *
 * Copyright 2018 Samsung Electronics All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the License.
 *
 ****************************************************************************/

#ifndef __EXTERNAL_LIBCXX_TEST_TC_CONTAINERS_H
#define __EXTERNAL_LIBCXX_TEST_TC_CONTAINERS_H
int tc_libcxx_containers_map_access_at(void);
int tc_libcxx_containers_map_access_empty(void);
int tc_libcxx_containers_map_access_index_key(void);
int tc_libcxx_containers_map_access_index_rv_key(void);
int tc_libcxx_containers_map_access_iterator(void);
int tc_libcxx_containers_map_access_max_size(void);
int tc_libcxx_containers_map_access_size(void);
int tc_libcxx_containers_map_cons_alloc(void);
int tc_libcxx_containers_map_cons_compare(void);
int tc_libcxx_containers_map_cons_compare_alloc(void);
int tc_libcxx_containers_map_cons_copy(void);
int tc_libcxx_containers_map_cons_copy_alloc(void);
int tc_libcxx_containers_map_cons_default(void);
int tc_libcxx_containers_map_cons_default_noexcept(void);
int tc_libcxx_containers_map_cons_default_recursive(void);
int tc_libcxx_containers_map_cons_dtor_noexcept(void);
int tc_libcxx_containers_map_cons_initializer_list(void);
int tc_libcxx_containers_map_cons_initializer_list_compare(void);
int tc_libcxx_containers_map_cons_initializer_list_compare_alloc(void);
int tc_libcxx_containers_map_cons_iter_iter(void);
int tc_libcxx_containers_map_cons_iter_iter_comp(void);
int tc_libcxx_containers_map_cons_iter_iter_comp_alloc(void);
int tc_libcxx_containers_map_cons_move(void);
int tc_libcxx_containers_map_cons_move_alloc(void);
int tc_libcxx_containers_map_cons_move_assign(void);
int tc_libcxx_containers_map_cons_move_assign_noexcept(void);
int tc_libcxx_containers_map_cons_move_noexcept(void);
int tc_libcxx_containers_map_modifiers_clear(void);
int tc_libcxx_containers_map_modifiers_emplace(void);
int tc_libcxx_containers_map_modifiers_emplace_hint(void);
int tc_libcxx_containers_map_modifiers_erase_iter(void);
int tc_libcxx_containers_map_modifiers_erase_iter_iter(void);
int tc_libcxx_containers_map_modifiers_erase_key(void);
int tc_libcxx_containers_map_modifiers_insert_cv(void);
int tc_libcxx_containers_map_modifiers_insert_iter_cv(void);
int tc_libcxx_containers_map_modifiers_insert_iter_iter(void);
int tc_libcxx_containers_map_modifiers_insert_iter_rv(void);
int tc_libcxx_containers_map_modifiers_insert_rv(void);
int tc_libcxx_containers_map_ops_count(void);
int tc_libcxx_containers_map_special_swap_noexcept(void);
int tc_libcxx_containers_map_types(void);
int tc_libcxx_containers_multimap_cons_alloc(void);
int tc_libcxx_containers_multimap_cons_assign_initializer_list(void);
int tc_libcxx_containers_multimap_cons_compare(void);
int tc_libcxx_containers_multimap_cons_compare_alloc(void);
int tc_libcxx_containers_multimap_cons_copy(void);
int tc_libcxx_containers_multimap_cons_copy_alloc(void);
int tc_libcxx_containers_multimap_cons_copy_assign(void);
int tc_libcxx_containers_multimap_cons_default(void);
int tc_libcxx_containers_multimap_cons_default_noexcept(void);
int tc_libcxx_containers_multimap_cons_dtor_noexcept(void);
int tc_libcxx_containers_multimap_cons_initializer_list(void);
int tc_libcxx_containers_multimap_cons_initializer_list_compare(void);
int tc_libcxx_containers_multimap_cons_initializer_list_compare_alloc(void);
int tc_libcxx_containers_multimap_cons_iter_iter(void);
int tc_libcxx_containers_multimap_cons_iter_iter(void);
int tc_libcxx_containers_multimap_cons_iter_iter_comp(void);
int tc_libcxx_containers_multimap_cons_iter_iter_comp_alloc(void);
int tc_libcxx_containers_multimap_cons_move_alloc(void);
int tc_libcxx_containers_multimap_cons_move_assign(void);
int tc_libcxx_containers_multimap_cons_move_assign_noexcept(void);
int tc_libcxx_containers_multimap_cons_move_noexcept(void);
int tc_libcxx_containers_multimap_modifiers_clear(void);
int tc_libcxx_containers_multimap_modifiers_emplace(void);
int tc_libcxx_containers_multimap_modifiers_emplace_hint(void);
int tc_libcxx_containers_multimap_modifiers_erase_iter(void);
int tc_libcxx_containers_multimap_modifiers_erase_iter_iter(void);
int tc_libcxx_containers_multimap_modifiers_erase_key(void);
int tc_libcxx_containers_multimap_modifiers_insert_cv(void);
int tc_libcxx_containers_multimap_modifiers_insert_initializer_list(void);
int tc_libcxx_containers_multimap_modifiers_insert_iter_iter(void);
int tc_libcxx_containers_multimap_modifiers_insert_iter_rv(void);
int tc_libcxx_containers_multimap_ops_count(void);
int tc_libcxx_containers_multimap_special_swap_noexcept(void);
int tc_libcxx_containers_multimap_size(void);
int tc_libcxx_containers_multimap_types(void);
int tc_libcxx_containers_unord_map_types(void);
int tc_libcxx_containers_unord_map_find_const(void);
int tc_libcxx_containers_unord_map_iterators(void);
int tc_libcxx_containers_unord_map_swap_swap_non_member(void);
int tc_libcxx_containers_unord_map_swap_swap_noexcept(void);
int tc_libcxx_containers_unord_map_cnstr_allocator(void);
int tc_libcxx_containers_unord_map_cnstr_copy_alloc(void);
int tc_libcxx_containers_unord_map_cnstr_range_size_hash(void);
int tc_libcxx_containers_unord_map_cnstr_move_assign_noexcept(void);
int tc_libcxx_containers_unord_map_cnstr_assign_init(void);
int tc_libcxx_containers_unord_map_cnstr_range_size(void);
int tc_libcxx_containers_unord_map_cnstr_range(void);
int tc_libcxx_containers_unord_map_cnstr_init_size_hash_equal(void);
int tc_libcxx_containers_unord_map_cnstr_size_hash(void);
int tc_libcxx_containers_unord_map_cnstr_move(void);
int tc_libcxx_containers_unord_map_cnstr_assign_copy(void);
int tc_libcxx_containers_unord_map_cnstr_dtor_noexcept(void);
int tc_libcxx_containers_unord_map_cnstr_move_alloc(void);
int tc_libcxx_containers_unord_map_cnstr_init_size_hash(void);
int tc_libcxx_containers_unord_map_cnstr_move_noexcept(void);
int tc_libcxx_containers_unord_map_cnstr_copy(void);
int tc_libcxx_containers_unord_map_cnstr_init(void);
int tc_libcxx_containers_unord_map_cnstr_size_pass(void);
int tc_libcxx_containers_unord_map_cnstr_range_size_hash_equal(void);
int tc_libcxx_containers_unord_map_cnstr_default_noexcept(void);
int tc_libcxx_containers_unord_map_cnstr_init_size_hash_equal_allocator(void);
int tc_libcxx_containers_unord_map_cnstr_size_hash_equal(void);
int tc_libcxx_containers_unord_map_cnstr_range_size_hash_equal_allocator(void);
int tc_libcxx_containers_unord_map_cnstr_assign_move(void);
int tc_libcxx_containers_unord_map_cnstr_init_size(void);
int tc_libcxx_containers_unord_map_cnstr_size_hash_equal_allocator(void);
int tc_libcxx_containers_unord_map_cnstr_default(void);
int tc_libcxx_containers_unord_map_cnstr_size(void);
int tc_libcxx_containers_unord_map_eq(void);
int tc_libcxx_containers_unord_map_bucket(void);
int tc_libcxx_containers_unord_map_equal_range_const(void);
int tc_libcxx_containers_unord_map_find_non_const(void);
int tc_libcxx_containers_unord_map_max_load_factor(void);
int tc_libcxx_containers_unord_map_swap_member(void);
int tc_libcxx_containers_unord_map_count(void);
int tc_libcxx_containers_unord_map_reserve(void);
int tc_libcxx_containers_unord_map_bucket_size(void);
int tc_libcxx_containers_unord_map_max_bucket_count(void);
int tc_libcxx_containers_unord_map_elem_at(void);
int tc_libcxx_containers_unord_map_elem_index(void);
int tc_libcxx_containers_unord_map_load_factor(void);
int tc_libcxx_containers_unord_map_equal_range_non_const(void);
int tc_libcxx_containers_unord_map_bucket_count(void);
int tc_libcxx_containers_unord_map_rehash(void);
int tc_libcxx_containers_unord_map_modifiers_insert_const_lvalue(void);
int tc_libcxx_containers_unord_map_modifiers_insert_hint_rvalue(void);
int tc_libcxx_containers_unord_map_modifiers_insert_init(void);
int tc_libcxx_containers_unord_map_modifiers_emplace_hint(void);
int tc_libcxx_containers_unord_map_modifiers_insert_rvalue(void);
int tc_libcxx_containers_unord_map_modifiers_erase_key(void);
int tc_libcxx_containers_unord_map_modifiers_erase_range(void);
int tc_libcxx_containers_unord_map_modifiers_emplace(void);
int tc_libcxx_containers_unord_map_modifiers_erase_const_iter(void);
int tc_libcxx_containers_unord_map_modifiers_clear(void);
int tc_libcxx_containers_unord_map_modifiers_insert_range(void);
int tc_libcxx_containers_unord_map_modifiers_insert_hint_const_lvalue(void);
int tc_libcxx_containers_unord_map_max_size(void);
int tc_libcxx_containers_unord_map_local_iterators(void);
int tc_libcxx_containers_unord_multimap_types(void);
int tc_libcxx_containers_unord_multimap_find_const(void);
int tc_libcxx_containers_unord_multimap_swap_swap_non_member(void);
int tc_libcxx_containers_unord_multimap_swap_swap_noexcept(void);
int tc_libcxx_containers_unord_multimap_iterators(void);
int tc_libcxx_containers_unord_multimap_eq(void);
int tc_libcxx_containers_unord_multimap_cnstr_allocator(void);
int tc_libcxx_containers_unord_multimap_cnstr_copy_alloc(void);
int tc_libcxx_containers_unord_multimap_cnstr_range_size_hash(void);
int tc_libcxx_containers_unord_multimap_cnstr_move_assign_noexcept(void);
int tc_libcxx_containers_unord_multimap_cnstr_assign_init(void);
int tc_libcxx_containers_unord_multimap_cnstr_range_size(void);
int tc_libcxx_containers_unord_multimap_cnstr_range(void);
int tc_libcxx_containers_unord_multimap_cnstr_init_size_hash_equal(void);
int tc_libcxx_containers_unord_multimap_cnstr_size_hash(void);
int tc_libcxx_containers_unord_multimap_cnstr_move(void);
int tc_libcxx_containers_unord_multimap_cnstr_assign_copy(void);
int tc_libcxx_containers_unord_multimap_cnstr_dtor_noexcept(void);
int tc_libcxx_containers_unord_multimap_cnstr_move_alloc(void);
int tc_libcxx_containers_unord_multimap_cnstr_init_size_hash(void);
int tc_libcxx_containers_unord_multimap_cnstr_move_noexcept(void);
int tc_libcxx_containers_unord_multimap_cnstr_copy(void);
int tc_libcxx_containers_unord_multimap_cnstr_init(void);
int tc_libcxx_containers_unord_multimap_cnstr_size(void);
int tc_libcxx_containers_unord_multimap_cnstr_range_size_hash_equal(void);
int tc_libcxx_containers_unord_multimap_cnstr_default_noexcept(void);
int tc_libcxx_containers_unord_multimap_cnstr_init_size_hash_equal_allocator(void);
int tc_libcxx_containers_unord_multimap_cnstr_size_hash_equal(void);
int tc_libcxx_containers_unord_multimap_cnstr_range_size_hash_equal_allocator(void);
int tc_libcxx_containers_unord_multimap_cnstr_assign_move(void);
int tc_libcxx_containers_unord_multimap_cnstr_init_size(void);
int tc_libcxx_containers_unord_multimap_cnstr_size_hash_equal_allocator(void);
int tc_libcxx_containers_unord_multimap_cnstr_default(void);
int tc_libcxx_containers_unord_multimap_cnstr_size_pass(void);
int tc_libcxx_containers_unord_multimap_bucket(void);
int tc_libcxx_containers_unord_multimap_equal_range_const(void);
int tc_libcxx_containers_unord_multimap_find_non_const(void);
int tc_libcxx_containers_unord_multimap_max_load_factor(void);
int tc_libcxx_containers_unord_multimap_swap_member(void);
int tc_libcxx_containers_unord_multimap_count(void);
int tc_libcxx_containers_unord_multimap_reserve(void);
int tc_libcxx_containers_unord_multimap_bucket_size(void);
int tc_libcxx_containers_unord_multimap_max_bucket_count(void);
int tc_libcxx_containers_unord_multimap_load_factor(void);
int tc_libcxx_containers_unord_multimap_equal_range_non_const(void);
int tc_libcxx_containers_unord_multimap_bucket_count(void);
int tc_libcxx_containers_unord_multimap_rehash(void);
int tc_libcxx_containers_unord_multimap_max_size(void);
int tc_libcxx_containers_unord_multimap_iterators(void);
int tc_libcxx_containers_unord_multimap_local_iterators(void);
int tc_libcxx_containers_unord_multimap_modifiers_insert_const_lvalue(void);
int tc_libcxx_containers_unord_multimap_modifiers_insert_hint_rvalue(void);
int tc_libcxx_containers_unord_multimap_modifiers_insert_init(void);
int tc_libcxx_containers_unord_multimap_modifiers_emplace_hint(void);
int tc_libcxx_containers_unord_multimap_modifiers_insert_rvalue(void);
int tc_libcxx_containers_unord_multimap_modifiers_erase_key(void);
int tc_libcxx_containers_unord_multimap_modifiers_erase_range(void);
int tc_libcxx_containers_unord_multimap_modifiers_emplace(void);
int tc_libcxx_containers_unord_multimap_modifiers_erase_const_iter(void);
int tc_libcxx_containers_unord_multimap_modifiers_clear(void);
int tc_libcxx_containers_unord_multimap_modifiers_insert_range(void);
int tc_libcxx_containers_unord_multimap_modifiers_insert_hint_const_lvalue(void);
int tc_libcxx_containers_unord_multimap_local_iterators(void);

int tc_libcxx_containers_vector_types(void);
int tc_libcxx_containers_vector_iterators(void);
int tc_libcxx_containers_vector_capacity_resize_size(void);
int tc_libcxx_containers_vector_capacity_shrink_to_fit(void);
int tc_libcxx_containers_vector_capacity_swap(void);
int tc_libcxx_containers_vector_capacity_capacity(void);
int tc_libcxx_containers_vector_capacity_reserve(void);
int tc_libcxx_containers_vector_capacity_resize_size_value(void);
int tc_libcxx_containers_vector_data_data_const(void);
int tc_libcxx_containers_vector_data_data(void);
int tc_libcxx_containers_vector_cons_construct_default(void);
int tc_libcxx_containers_vector_cons_copy_alloc(void);
int tc_libcxx_containers_vector_cons_move_assign_noexcept(void);
int tc_libcxx_containers_vector_cons_initializer_list(void);
int tc_libcxx_containers_vector_cons_initializer_list_alloc(void);
int tc_libcxx_containers_vector_cons_move(void);
int tc_libcxx_containers_vector_cons_assign_copy(void);
int tc_libcxx_containers_vector_cons_dtor_noexcept(void);
int tc_libcxx_containers_vector_cons_move_alloc(void);
int tc_libcxx_containers_vector_cons_assign_initializer_list(void);
int tc_libcxx_containers_vector_cons_move_noexcept(void);
int tc_libcxx_containers_vector_cons_construct_size_value(void);
int tc_libcxx_containers_vector_cons_copy(void);
int tc_libcxx_containers_vector_cons_op_equal_initializer_list(void);
int tc_libcxx_containers_vector_cons_default_noexcept(void);
int tc_libcxx_containers_vector_cons_assign_move(void);
int tc_libcxx_containers_vector_cons_construct_size_value_alloc(void);
int tc_libcxx_containers_vector_cons_construct_size(void);
int tc_libcxx_containers_vector_modifiers_emplace_back(void);
int tc_libcxx_containers_vector_modifiers_push_back_rvalue(void);
int tc_libcxx_containers_vector_modifiers_push_back(void);
int tc_libcxx_containers_vector_modifiers_erase_iter(void);
int tc_libcxx_containers_vector_modifiers_insert_iter_iter_iter(void);
int tc_libcxx_containers_vector_modifiers_insert_iter_rvalue(void);
int tc_libcxx_containers_vector_modifiers_emplace(void);
int tc_libcxx_containers_vector_modifiers_insert_iter_value(void);
int tc_libcxx_containers_vector_modifiers_insert_iter_initializer_list(void);
int tc_libcxx_containers_vector_modifiers_erase_iter_iter(void);
int tc_libcxx_containers_vector_modifiers_emplace_extra(void);
int tc_libcxx_containers_vector_special_swap(void);
int tc_libcxx_containers_vector_special_swap_noexcept(void);
int tc_libcxx_containers_vector_bool_resize_size(void);
int tc_libcxx_containers_vector_bool_construct_default(void);
int tc_libcxx_containers_vector_bool_shrink_to_fit(void);
int tc_libcxx_containers_vector_bool_copy_alloc(void);
int tc_libcxx_containers_vector_bool_types(void);
int tc_libcxx_containers_vector_bool_swap(void);
int tc_libcxx_containers_vector_bool_move_assign_noexcept(void);
int tc_libcxx_containers_vector_bool_initializer_list(void);
int tc_libcxx_containers_vector_bool_iterators(void);
int tc_libcxx_containers_vector_bool_push_back(void);
int tc_libcxx_containers_vector_bool_erase_iter(void);
int tc_libcxx_containers_vector_bool_initializer_list_alloc(void);
int tc_libcxx_containers_vector_bool_insert_iter_iter_iter(void);
int tc_libcxx_containers_vector_bool_construct_iter_iter(void);
int tc_libcxx_containers_vector_bool_insert_iter_value(void);
int tc_libcxx_containers_vector_bool_insert_iter_size_value(void);
int tc_libcxx_containers_vector_bool_move(void);
int tc_libcxx_containers_vector_bool_assign_copy(void);
int tc_libcxx_containers_vector_bool_dtor_noexcept(void);
int tc_libcxx_containers_vector_bool_capacity(void);
int tc_libcxx_containers_vector_bool_move_alloc(void);
int tc_libcxx_containers_vector_bool_assign_initializer_list(void);
int tc_libcxx_containers_vector_bool_move_noexcept(void);
int tc_libcxx_containers_vector_bool_insert_iter_initializer_list(void);
int tc_libcxx_containers_vector_bool_reserve(void);
int tc_libcxx_containers_vector_bool_construct_size_value(void);
int tc_libcxx_containers_vector_bool_copy(void);
int tc_libcxx_containers_vector_bool_construct_iter_iter_alloc(void);
int tc_libcxx_containers_vector_bool_op_equal_initializer_list(void);
int tc_libcxx_containers_vector_bool_default_noexcept(void);
int tc_libcxx_containers_vector_bool_assign_move(void);
int tc_libcxx_containers_vector_bool_erase_iter_iter(void);
int tc_libcxx_containers_vector_bool_swap_noexcept(void);
int tc_libcxx_containers_vector_bool_construct_size_value_alloc(void);
int tc_libcxx_containers_vector_bool_resize_size_value(void);
int tc_libcxx_containers_vector_bool_construct_size(void);

int tc_libcxx_containers_list_types(void);
int tc_libcxx_containers_list_modifiers_pop_back(void);
int tc_libcxx_containers_list_modifiers_emplace_back(void);
int tc_libcxx_containers_list_modifiers_push_back_rvalue(void);
int tc_libcxx_containers_list_modifiers_push_back(void);
int tc_libcxx_containers_list_modifiers_erase_iter(void);
int tc_libcxx_containers_list_modifiers_insert_iter_iter_iter(void);
int tc_libcxx_containers_list_modifiers_insert_iter_rvalue(void);
int tc_libcxx_containers_list_modifiers_emplace(void);
int tc_libcxx_containers_list_modifiers_insert_iter_value(void);
int tc_libcxx_containers_list_modifiers_insert_iter_size_value(void);
int tc_libcxx_containers_list_modifiers_emplace_front(void);
int tc_libcxx_containers_list_modifiers_insert_iter_initializer_list(void);
int tc_libcxx_containers_list_modifiers_clear(void);
int tc_libcxx_containers_list_modifiers_pop_front(void);
int tc_libcxx_containers_list_modifiers_erase_iter_iter(void);
int tc_libcxx_containers_list_modifiers_push_front(void);
int tc_libcxx_containers_list_modifiers_push_front_rvalue(void);
int tc_libcxx_containers_list_cons_copy_alloc(void);
int tc_libcxx_containers_list_cons_move_assign_noexcept(void);
int tc_libcxx_containers_list_cons_initializer_list(void);
int tc_libcxx_containers_list_cons_initializer_list_alloc(void);
int tc_libcxx_containers_list_cons_size_value_alloc(void);
int tc_libcxx_containers_list_cons_move(void);
int tc_libcxx_containers_list_cons_default_stack_alloc(void);
int tc_libcxx_containers_list_cons_assign_copy(void);
int tc_libcxx_containers_list_cons_dtor_noexcept(void);
int tc_libcxx_containers_list_cons_move_alloc(void);
int tc_libcxx_containers_list_cons_assign_initializer_list(void);
int tc_libcxx_containers_list_cons_move_noexcept(void);
int tc_libcxx_containers_list_cons_copy(void);
int tc_libcxx_containers_list_cons_op_equal_initializer_list(void);
int tc_libcxx_containers_list_cons_default_noexcept(void);
int tc_libcxx_containers_list_cons_assign_move(void);
int tc_libcxx_containers_list_cons_size_type(void);
int tc_libcxx_containers_list_cons_default(void);
int tc_libcxx_containers_list_special_swap(void);
int tc_libcxx_containers_list_special_swap_noexcept(void);
int tc_libcxx_containers_list_iterators(void);
int tc_libcxx_containers_list_ops_remove_if(void);
int tc_libcxx_containers_list_ops_splice_pos_list_iter_iter(void);
int tc_libcxx_containers_list_ops_unique(void);
int tc_libcxx_containers_list_ops_sort(void);
int tc_libcxx_containers_list_ops_unique_pred(void);
int tc_libcxx_containers_list_ops_merge(void);
int tc_libcxx_containers_list_ops_splice_pos_list(void);
int tc_libcxx_containers_list_ops_splice_pos_list_iter(void);
int tc_libcxx_containers_list_ops_sort_comp(void);
int tc_libcxx_containers_list_ops_remove(void);
int tc_libcxx_containers_list_ops_reverse(void);
int tc_libcxx_containers_list_ops_merge_comp(void);
int tc_libcxx_containers_list_capacity_resize_size(void);
int tc_libcxx_containers_list_capacity_resize_size_value(void);
int tc_libcxx_containers_forwardlist_types(void);
int tc_libcxx_containers_forwardlist_cons_copy_alloc(void);
int tc_libcxx_containers_forwardlist_cons_assign_range(void);
int tc_libcxx_containers_forwardlist_cons_move_assign_noexcept(void);
int tc_libcxx_containers_forwardlist_cons_size_value_alloc(void);
int tc_libcxx_containers_forwardlist_cons_range_alloc(void);
int tc_libcxx_containers_forwardlist_cons_assign_init(void);
int tc_libcxx_containers_forwardlist_cons_range(void);
int tc_libcxx_containers_forwardlist_cons_move(void);
int tc_libcxx_containers_forwardlist_cons_assign_copy(void);
int tc_libcxx_containers_forwardlist_cons_dtor_noexcept(void);
int tc_libcxx_containers_forwardlist_cons_move_alloc(void);
int tc_libcxx_containers_forwardlist_cons_move_noexcept(void);
int tc_libcxx_containers_forwardlist_cons_copy(void);
int tc_libcxx_containers_forwardlist_cons_init(void);
int tc_libcxx_containers_forwardlist_cons_size(void);
int tc_libcxx_containers_forwardlist_cons_default_noexcept(void);
int tc_libcxx_containers_forwardlist_cons_assign_move(void);
int tc_libcxx_containers_forwardlist_cons_alloc_pass(void);
int tc_libcxx_containers_forwardlist_cons_assign_op_init(void);
int tc_libcxx_containers_forwardlist_cons_default(void);
int tc_libcxx_containers_forwardlist_cons_assign_size_value(void);
int tc_libcxx_containers_forwardlist_cons_size_value(void);
int tc_libcxx_containers_forwardlist_cons_init_alloc(void);
int tc_libcxx_containers_forwardlist_cons_size(void);
int tc_libcxx_containers_forwardlist_modifiers_erase_after_one(void);
int tc_libcxx_containers_forwardlist_modifiers_resize_size(void);
int tc_libcxx_containers_forwardlist_modifiers_insert_after_rv(void);
int tc_libcxx_containers_forwardlist_modifiers_insert_after_size_value(void);
int tc_libcxx_containers_forwardlist_modifiers_emplace_front(void);
int tc_libcxx_containers_forwardlist_modifiers_insert_after_const(void);
int tc_libcxx_containers_forwardlist_modifiers_insert_after_range(void);
int tc_libcxx_containers_forwardlist_modifiers_insert_after_init(void);
int tc_libcxx_containers_forwardlist_modifiers_clear(void);
int tc_libcxx_containers_forwardlist_modifiers_erase_after_many(void);
int tc_libcxx_containers_forwardlist_modifiers_pop_front(void);
int tc_libcxx_containers_forwardlist_modifiers_push_front_const(void);
int tc_libcxx_containers_forwardlist_modifiers_push_front_rv(void);
int tc_libcxx_containers_forwardlist_modifiers_resize_size_value(void);
int tc_libcxx_containers_forwardlist_modifiers_emplace_after(void);
int tc_libcxx_containers_forwardlist_access_front(void);
int tc_libcxx_containers_forwardlist_ops_remove_if(void);
int tc_libcxx_containers_forwardlist_ops_unique(void);
int tc_libcxx_containers_forwardlist_ops_sort(void);
int tc_libcxx_containers_forwardlist_ops_unique_pred(void);
int tc_libcxx_containers_forwardlist_ops_merge(void);
int tc_libcxx_containers_forwardlist_ops_splice_after_one(void);
int tc_libcxx_containers_forwardlist_ops_sort_pred(void);
int tc_libcxx_containers_forwardlist_ops_remove(void);
int tc_libcxx_containers_forwardlist_ops_reverse(void);
int tc_libcxx_containers_forwardlist_ops_merge_pred(void);
int tc_libcxx_containers_forwardlist_ops_splice_after_range(void);
int tc_libcxx_containers_forwardlist_ops_splice_after_flist(void);
int tc_libcxx_containers_forwardlist_iter_before_begin(void);
int tc_libcxx_containers_forwardlist_iter_iterators(void);
int tc_libcxx_containers_forwardlist_spec_member_swap(void);
int tc_libcxx_containers_forwardlist_spec_non_member_swap(void);
int tc_libcxx_containers_forwardlist_spec_relational(void);
int tc_libcxx_containers_forwardlist_spec_swap_noexcept(void);
#endif
