/****************************************************************************
 *
 * Copyright 2018 Samsung Electronics All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the License.
 *
 ****************************************************************************/
//===-------------------------- bind.cpp ----------------------------------===//
//
//                     The LLVM Compiler Infrastructure
//
// This file is dual licensed under the MIT and the University of Illinois Open
// Source Licenses. See LICENSE.TXT for details.
//
//===----------------------------------------------------------------------===//

#define _LIBCPP_BUILDING_BIND
#include "functional"

_LIBCPP_BEGIN_NAMESPACE_STD

namespace placeholders
{

const __ph<1>   _1{};
const __ph<2>   _2{};
const __ph<3>   _3{};
const __ph<4>   _4{};
const __ph<5>   _5{};
const __ph<6>   _6{};
const __ph<7>   _7{};
const __ph<8>   _8{};
const __ph<9>   _9{};
const __ph<10> _10{};

}  // placeholders

_LIBCPP_END_NAMESPACE_STD
