/*!
 *  @file       isp_oid.h
 *  @brief      Headerfile : definitions for oid
 *  @author     kiseok.bae
 *  @version    v0.90 : 2016.9.29 initial
 *
 */

#ifndef ISP_OID_H_
#define ISP_OID_H_

/*
 *		OID LIST
 */
#define OIDMAX_HMAC         (4)
#define OID_HMAC_SHA1_160   (0x00011100)
#define OID_HMAC_SHA2_256   (0x00012300)
#define OID_HMAC_SHA2_384   (0x00012400)
#define OID_HMAC_SHA2_512   (0x00012500)

#define OIDMAX_HASH         (8)
#define OID_SHA1_160        (0x00001100)
#define OID_SHA2_256        (0x00002300)
#define OID_SHA2_384        (0x00002400)
#define OID_SHA2_512        (0x00002500)
#define OID_SHA3_224        (0x00003200)
#define OID_SHA3_256        (0x00003300)
#define OID_SHA3_384        (0x00003400)
#define OID_SHA3_512        (0x00003500)

#define OIDMAX_DH           (2)
#define OID_DH_1024         (0x00001191)
#define OID_DH_2048         (0x00002392)

#define OIDMAX_ECC          (6)
#define OID_ECC_P192        (0x00000011)
#define OID_ECC_P224        (0x00000012)
#define OID_ECC_P256        (0x00000013)
#define OID_ECC_P384        (0x00000014)
#define OID_ECC_P521        (0x00000015)
#define OID_ECC_BP256       (0x00000053)

#define OIDMAX_RSA          (2)
#define OID_RSA_1024        (0x000000B1)
#define OID_RSA_2048        (0x000000B2)

#define OIDMAX_ECDSA                (24)
#define OID_ECDSA_BP256_SHA1_160    (OID_ECC_BP256 | OID_SHA1_160)
#define OID_ECDSA_BP256_SHA2_256    (OID_ECC_BP256 | OID_SHA2_256)
#define OID_ECDSA_BP256_SHA2_384    (OID_ECC_BP256 | OID_SHA2_384)
#define OID_ECDSA_BP256_SHA2_512    (OID_ECC_BP256 | OID_SHA2_512)

#define OID_ECDSA_P192_SHA1_160     (OID_ECC_P192 | OID_SHA1_160)
#define OID_ECDSA_P192_SHA2_256     (OID_ECC_P192 | OID_SHA2_256)
#define OID_ECDSA_P192_SHA2_384     (OID_ECC_P192 | OID_SHA2_384)
#define OID_ECDSA_P192_SHA2_512     (OID_ECC_P192 | OID_SHA2_512)
#define OID_ECDSA_P224_SHA1_160     (OID_ECC_P224 | OID_SHA1_160)
#define OID_ECDSA_P224_SHA2_256     (OID_ECC_P224 | OID_SHA2_256)
#define OID_ECDSA_P224_SHA2_384     (OID_ECC_P224 | OID_SHA2_384)
#define OID_ECDSA_P224_SHA2_512     (OID_ECC_P224 | OID_SHA2_512)
#define OID_ECDSA_P256_SHA1_160     (OID_ECC_P256 | OID_SHA1_160)
#define OID_ECDSA_P256_SHA2_256     (OID_ECC_P256 | OID_SHA2_256)
#define OID_ECDSA_P256_SHA2_384     (OID_ECC_P256 | OID_SHA2_384)
#define OID_ECDSA_P256_SHA2_512     (OID_ECC_P256 | OID_SHA2_512)
#define OID_ECDSA_P384_SHA1_160     (OID_ECC_P384 | OID_SHA1_160)
#define OID_ECDSA_P384_SHA2_256     (OID_ECC_P384 | OID_SHA2_256)
#define OID_ECDSA_P384_SHA2_384     (OID_ECC_P384 | OID_SHA2_384)
#define OID_ECDSA_P384_SHA2_512     (OID_ECC_P384 | OID_SHA2_512)
#define OID_ECDSA_P521_SHA1_160     (OID_ECC_P521 | OID_SHA1_160)
#define OID_ECDSA_P521_SHA2_256     (OID_ECC_P521 | OID_SHA2_256)
#define OID_ECDSA_P521_SHA2_384     (OID_ECC_P521 | OID_SHA2_384)
#define OID_ECDSA_P521_SHA2_512     (OID_ECC_P521 | OID_SHA2_512)

#endif							/*ISP_OID_H_ */
